<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";
@Component({
  components: {
    Store: () => import("./Store/index.vue"),
    // PaymentMethod: () => import("./PaymentMethod/index.vue"),
  },
})
export default class AdminSettingsPaymentComponent extends Vue {
  tab = 0;

  stats = {
    amount: 0,
    order: 0,
    profit: 0,
    productCost: 0,
  };

  sellerId = "";
  sellerDetail: any = {};

  mounted() {
    this.sellerId = this.$route.params.id || "";
    if (this.sellerId) {
      this.onGetDetail();
      this.onGetStats();
      this.onGetListStore();
      this.onGetListPayment();
    }
  }

  async onGetDetail() {
    try {
      const response = await this.$api.userAdmin.sellerDetail(this.sellerId);
      if (response?.data) {
        this.sellerDetail = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetStats() {
    try {
      const response = await this.$api.stats.statsAdminSeller(this.sellerId);
      if (response?.data) {
        const { amount, order, profit, productCost } = response.data;
        this.stats = {
          amount,
          order,
          profit,
          productCost,
        };
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onChangeStatus(seller: any) {
    try {
      if (seller.isActive) {
        await this.$api.userAdmin.activeUser(seller._id);
      } else {
        await this.$api.userAdmin.deactiveUser(seller._id);
      }
      this.$pushNotification.success("Successful status change");
      this.onGetDetail();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListStore() {
    try {
      const config = {
        litmit: 25,
        page: 1,
        search: "",
        sellerId: this.sellerId,
      };
      this.$store.dispatch("masterUsers/onGetStoreSeller", {
        ctx: this,
        query: config,
      });
      this.$store.commit("masterUsers/setSellerId", this.sellerId);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListPayment() {
    try {
      this.$store.dispatch("masterUsers/onGetListPayment", {
        ctx: this,
        sellerId: this.sellerId,
      });
      this.$store.commit("masterUsers/setSellerId", this.sellerId);
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
}
</script>

<style></style>
